package Fairness.Graphing;

import edu.rit.numeric.ListXYSeries;

/**
 * NamedListXYSeries extends a ListXYSeries to have a name.
 *
 * @author Jason Winnebeck
 */
public class NamedListXYSeries extends ListXYSeries implements NamedXYSeries {
	private final String name;

    /**
     * Constructs a new NamedListXYSeries with the given name.
     */
    public NamedListXYSeries( String name ) {
		this.name = name;
	}

    /**
     * Returns the name given to this NamedListXYSeries
     */
    public String getName() {
		return name;
	}
}
