package Fairness;

import org.junit.Test;
import static org.junit.Assert.*;

import java.util.Random;

/**
 * NumberUtilTest
 *
 * @author Jason Winnebeck
 */
public class NumberUtilTest {
    @Test public void testGetDigit() {
        assertEquals( 0xD, NumberUtil.getDigit( 0xDEADBEEF, 0 ) );
        assertEquals( 0xE, NumberUtil.getDigit( 0xDEADBEEF, 1 ) );
        assertEquals( 0xA, NumberUtil.getDigit( 0xDEADBEEF, 2 ) );
        assertEquals( 0xD, NumberUtil.getDigit( 0xDEADBEEF, 3 ) );
        assertEquals( 0xB, NumberUtil.getDigit( 0xDEADBEEF, 4 ) );
        assertEquals( 0xE, NumberUtil.getDigit( 0xDEADBEEF, 5 ) );
        assertEquals( 0xE, NumberUtil.getDigit( 0xDEADBEEF, 6 ) );
        assertEquals( 0xF, NumberUtil.getDigit( 0xDEADBEEF, 7 ) );
    }

    @Test public void testNumMatchingPrefix() {
        assertEquals( 0, NumberUtil.numMatchingPrefix( 0xAAAAAAAA, 0xBBBBBBBB ) );
        assertEquals( 1, NumberUtil.numMatchingPrefix( 0xBAAAAAAA, 0xBBBBBBBB ) );
        assertEquals( 4, NumberUtil.numMatchingPrefix( 0xBBBBAAAA, 0xBBBBBBBB ) );
    }

    @Test public void testRandomWithPrefix() {
        Random rnd = new Random();

        int prefix = 0xAB;
        boolean ok1 = false;
        boolean ok2 = false;

        for ( int i = 0; i < 1000; ++i ) {
            int num = NumberUtil.getRandomWithPrefix( prefix, 2, rnd );
            assertEquals( 0xA, NumberUtil.getDigit( num, 0 ) );
            assertEquals( 0xB, NumberUtil.getDigit( num, 1 ) );
            ok1 |= NumberUtil.getDigit( num, 3 ) != 0;

            num = NumberUtil.getRandomWithPrefix( prefix, 1, rnd );
            assertEquals( 0xB, NumberUtil.getDigit( num, 0 ) );
            ok2 |= NumberUtil.getDigit( num, 2 ) != 0;
        }

        assertTrue( ok1 );
        assertTrue( ok2 );
    }
}
